/*
 * FILE      : lp_dump.c
 * SYSTEM    : ktAό`Atsgđ^ako
 * FUNCTION  : ez̃_v
 * AUTHOR    : N.Tsuchiya  2000.02.28
 */
static char	*__file =__FILE__;  /* should be copied into all .c files   */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "lp_ssc.h"
#include "lpvect3.h"
#include "lplufact.h"

/*	ID_lpvect2_dump	O|C^tz_v
/*******************************************************************/
int lpvect2_dump(char *title, VECT2 *vect )
{
	int rc = 0, i, cnt = 0;
	Dprintf( "%s", title);
	for( i = vect->top; i >= 0; i = vect->next[i] ) {
		Dprintf( "(%d:%g)", i, vect->va[i]);
		if( (++cnt%10) == 0 ) Dprintf( "\n          " );
	}
	if( (cnt%10) != 0 ) Dprintf( "\n" );
	return rc;
}
/*	ID_lu_dump_pf	pf[]̃_v
/*******************************************************************/
int lu_dump_lu( LUMATRX *lu, int head, int j )
{
	int		i, maxloop = 0;
	LUAVS *aav = &lu->av;

	if( j >= 0 ) {
		Dprintf( " Ŕԍ(%d) av[]̐擪(%d)\n", j, head);
		for( i = head; i >= 0; i = aav->nexti[i] ) {
			Dprintf( "    av[%d] (%d)s(%d)l(%.7g) \n", i, j, aav->i[i], aav->v[i] );
//			if( maxloop > lps->b.sz ) { CHKB(0, maxloop, lps->b.sz); break; }
			if( maxloop > lu->n_row ) { CHKB(0, maxloop, lu->n_row); break; }
		}
	} else {
		Dprintf( " av[]̐擪\n" );
		for( i = head; i >= 0; i = aav->nexti[i] ) {
			Dprintf( "    av[%d] s(%d)l(%.7g) \n", i, aav->i[i], aav->v[i] );
//			if( maxloop > lps->b.sz ) { CHKB(0, maxloop, lps->b.sz); break; }
			if( maxloop > lu->n_row ) { CHKB(0, maxloop, lu->n_row); break; }
		}
	}
	return 0;
}
/*	ID_lu_dump_L	ks̃_v
/*******************************************************************/
int lu_dump_L(LUFACT *b)
{
	int		j, maxloop = 0;
//	Dprintf( "ks sz(%d) \n", lps->b.sz );
	Dprintf( "ks sz(%d) \n", b->sz );   //??b->sz͂@NT110315
	for( j = b->lw.allbgnpfv; j >= 0; j = b->lw.pfv[j].allnext ) { CHKB(j, b->lw.pfv[j].dim , j);
		lu_dump_lu( b->lu, b->lw.pfv[j].pf_head, j );
//		if( maxloop > lps->b.sz ) { CHKB(0, maxloop, lps->b.sz); break; }
		if( maxloop > b->sz ) { CHKB(0, maxloop, b->sz); break; }   //??b->szw͂@NT110315
	}
	return 0;
}
/*	ID_lu_dump_R	ks̃_v
/*******************************************************************/
int lu_dump_R(LUFACT *b)
{
	int		j, maxloop = 0;
	Dprintf( "qŕϊq b->n_br(%d) \n", b->n_br );
	for( j = 0; j < b->n_br; ++j ) { /* us^Ł~u */
		lu_dump_lu( b->lu, b->br.pfv[j].pf_head, b->br.pfv[j].dim );
		if( maxloop > 100 ) { CHKB(0, maxloop, 100); break; }
	}
	return 0;
}
/*	ID_lu_dump_U	ts̃_v
/*******************************************************************/
int lu_dump_U(LUFACT *b)
{
	int		j, maxloop = 0;
//	Dprintf( "ts sz(%d) \n", lps->b.sz );
	Dprintf( "ts sz(%d) \n", b->sz );
	for( j = b->up.allbgnpfv; j >= 0; j = b->up.pfv[j].allnext ) { CHKB(j, b->up.pfv[j].dim , j);
		lu_dump_lu( b->lu, b->up.pfv[j].pf_head, j );
//		if( maxloop > lps->b.sz ) { CHKB(0, maxloop, lps->b.sz); break; }
		if( maxloop > b->sz ) { CHKB(0, maxloop, b->sz); break; }
	}
	return 0;
}
/*	ID_lu_dump_match	}b`Õ_v
/*******************************************************************/
int lu_dump_match(int (*mt)[2], int num, char *titl)
{
	int		i;
	Dprintf("%s", titl);
	for( i = 0; i < num; ++i )
		Dprintf("%c(%d %d)", (i%10)?' ':'\n', mt[i][0], mt[i][1]);
	Dprintf("\n");
	return 0;
}
/*	ID_lp_dump_VECT1	ϐÃ_v
/*******************************************************************/
int lp_dump_VECT1( char *title, VECTIN *cvect, int cvect_head)
{
	int		i;
	Dprintf( "%s \n", title );
	for( i = cvect_head; i >= 0; i = cvect[i].next ) {
		Dprintf( "    s[%d] (%d) %g\n", i, cvect[i].usef, cvect[i].v );
	}
	return 0;
}
