/*
 * FILE      : lp_ssc.c
 * Copyright (C) 2000 Sogen System Co., Ltd
 * SYSTEM    : ktAό`Atsgđ^ako
 * FUNCTION  : xNg̊evZȂ
 * AUTHOR    : N.Tsuchiya  2000.02.28
 */
static char	*__file =__FILE__;  /* should be copied into all .c files   */
#include <stdio.h>
#include <stdlib.h>
#include <memory.h>
//#include "lpcommon.h"
#include "lp_ssc.h"

/*	ID_basenm	t@CfBNg폜
/*******************************************************************/
void *Realloc(void **ret, size_t siz)
{
	void *pwk;
	pwk = realloc( *ret, siz );
	if( pwk != 0 ) *ret = pwk;
	return pwk;
}
/*	ID_basenm	t@CfBNg폜
/*******************************************************************/
static char *basenm(char *file)
{
	char	*p = file;
	for( p = file; *file; ++file )
		if( *file == '\\' ) p = file + 1;
	return p;
}
/*	ID_resetjmp	G[ɖ߂邽߂ɃX^bNNA NT040325add
/*******************************************************************/
int lp_resetjmp  ()
{
     /* G[ɖ߂邽߂ɃX^bNNA */
	memset( &lp_mark, 0, sizeof(lp_mark) );
	lp_mark_set_flag = 0;  /* setjmp( lp_mark )LtO */
	return 0;
}
/*	ID_chk_ab	CHKA()ACHKB()}Nňُ펞̃bZ[WóBPOOĂ΂Ǝs~
/*******************************************************************/
int lp_chk_ab  (int t,long lx,long ly,long lz,char *file,int line,char *sx,char *sy,char *sz )
{
	/* CHKG[QOO 0:I 1:Ȃ(o͂) 2:Ȃ(100so)NT030304add */
	if( lp_chk_ <= 200 || g_ssc.continue_200_chk != 1 )
		Dprintf("*** CHK%c error <== %8s(%d) %s(%ld) %s(%ld) %s(%ld)\n",
			t?'B':'A', basenm(file), line, sx, lx, sy, ly, sz, lz ) ;
	if( lp_chk_ > 200 && g_ssc.continue_200_chk == 0) {
		if( lp_mark_set_flag ) longjmp( lp_mark, -1 ); /* setjmp()Ăяoʒu-1Ŗ߂ NT020223 */
/*		lp_free(); exit(99); NT020223 */
	}
	return(1);
}
/*	ID_chk_xy	CHKX()ACHKY()}Nňُ펞̃bZ[WóBPOOĂ΂Ǝs~
/*******************************************************************/
int lp_chk_xy  (int t,double lx,double ly,double lz,char *file,int line,char *sx,char *sy,char *sz )
{
	/* CHKG[QOO 0:I 1:Ȃ(o͂) 2:Ȃ(100so)NT030304add */
	if( lp_chk_ <= 200 || g_ssc.continue_200_chk != 1 )
		Dprintf("*** CHK%c error <== %8s(%d) %s(%g) %s(%g) %s(%g)\n",
			t?'Y':'X', basenm(file), line, sx, lx, sy, ly, sz, lz ) ;
	if( lp_chk_ > 200 && g_ssc.continue_200_chk == 0) {
		if( lp_mark_set_flag ) longjmp( lp_mark, -1 ); /* setjmp()Ăяoʒu-1Ŗ߂ NT020223 */
/*		lp_free(); exit(99); NT020223 */
	}
	return(1);
}
/*	ID_ssc_get_chk	CHKG[̎擾
/*******************************************************************/
int ssc_get_chk(void)
{
	return(lp_chk_);
}
/*	ID_ssc_set_chk	CHKG[̐ݒ
/*******************************************************************/
int ssc_set_chk(int chk)
{
	lp_chk_ = chk;
	return 0;
}
/*	ID_trace_ab	֐g[X̃bZ[WóB
/*******************************************************************/
int lp_trace_ab (int type,char *file,int line,int xx )
{
	static char	*arc[] = {" ==>", " -- ", "<== "};
	Dprintf("%s %-8s(%3d) %c", arc[type], basenm(file), line, xx?'\n':' ') ;
	return(0);
}
/*	ID_sscfree	mۂ̉iDLLłł͏ʂŊmۂDLLł͉oȂj
/*******************************************************************/
int sscfree( void **ptr, char *mes, char *fname, int line)
{
	if( *ptr ) {
		free(*ptr);
		*ptr = NULL;
	}
	return(0);
}
#define	FABS_MC(x)	(((x)<0.0)?(-(x)):(x)) /* fabs()֐ďoŒx̂ŁBGƒxȂ */
#define ISEQUAL_RE(x,y,epsi)	(WK2=FABS_MC(y),WK2=(WK2<1.0)?(epsi):WK2*(epsi),(x)-(y) <= WK2 && (x)-(y) >= -WK2)
#define ISZERO_E(x,epsi)	(-(epsi)<=(x) && (x)<=(epsi))
static double	WK2;
/*	ID_sscGosaHantei	Ɣ̑Ό덷
/*******************************************************************/
int sscGosaHantei( double moto, double shin, double epsi,
	double *gosa_hi )   /* o |^Z|1.0Ƃ̍BOȂ瑼̒l̂ */
{
	int rc = 0;
	if( ISEQUAL_RE(shin, moto, epsi) ) goto        quit;
	if( moto == 0.0 ) { *gosa_hi = shin;
	} else if( shin == 0.0 ) { *gosa_hi = moto;
	} else {
		if( (*gosa_hi = moto / shin) < 0.0 ) *gosa_hi = - *gosa_hi;
		if( *gosa_hi < 1.0 ) *gosa_hi = 1.0 / *gosa_hi;
		*gosa_hi = *gosa_hi - 1.0;                /* *gosa_hi = |^Z|1.0Ƃ̍ */
	}
	if( moto > 1.0 && ISZERO_E(*gosa_hi, epsi) ) goto   quit;
	rc = 1;
quit: return rc;
}
/*	ID_ssc_dump_double2	z̉`_v(]o)
/*******************************************************************/
int ssc_dump_double2( double *v, int n, char *titl, int sign )
{
	int		i, i0, cnt;

	for( i0 = 0; i0 < n; i0 = i ) {
		Dprintf( "%s\t", titl);
		for( i = i0, cnt = 0; i < n && cnt < 20; ++i, ++cnt ) {
			Dprintf( " %g", ((sign<0) ? -v[i] : v[i]) );
		}
		Dprintf( "\n");
	}
	return 0;
}
/*	ID_ssc_dump_double	z̉`_v
/*******************************************************************/
int ssc_dump_double( double *v, int n, char *titl, int mode )
{
	int		i, i0, cnt;

/*	Dprintf( "%s n(%d) \n", titl, n ); /* */
	if( mode == 0 ) {
		for( i0 = 0; i0 < n; i0 = i ) {
			Dprintf( "%s\t", titl);
			for( i = i0, cnt = 0; i < n && cnt < 20; ++i, ++cnt ) {
				Dprintf( " %g", v[i] );
			}
			Dprintf( "\n");
		}
	} else {
		for( i0 = 0; i0 < n; i0 = i ) {
			Dprintf( "%s\t", titl);
			for( i = i0, cnt = 0; i < n && cnt < 20; ++i, ++cnt ) {
				Dprintf( " %g", v[i] );
			}
			Dprintf( "\n");
		}
	}
	return 0;
}
/*	ID_ssc_dump_int	z̉`_v
/*******************************************************************/
int ssc_dump_int( int *v, int n, char *titl, int mode )
{
	int		i, i0, cnt;

/*	Dprintf( "%s n(%d) \n", titl, n ); /* */
	if( mode == 0 ) {
		for( i0 = 0; i0 < n; i0 = i ) {
			Dprintf( "%s\t", titl);
			for( i = i0, cnt = 0; i < n && cnt < 20; ++i, ++cnt ) {
				Dprintf( " %d", v[i] );
			}
			Dprintf( "\n");
		}
	} else {
		for( i0 = 0; i0 < n; i0 = i ) {
			Dprintf( "%s\t", titl);
			for( i = i0, cnt = 0; i < n && cnt < 20; ++i, ++cnt ) {
				Dprintf( " %d", v[i] );
			}
			Dprintf( "\n");
		}
	}
	return 0;
}
/*	ID_ssc_dump_char	charz̉`_v
/*******************************************************************/
int ssc_dump_char( char *v, int n, char *titl, int mode )
{
	int		i, i0, cnt;

/*	Dprintf( "%s n(%d) \n", titl, n ); /* */
	if( mode == 0 ) {
		for( i0 = 0; i0 < n; i0 = i ) {
			Dprintf( "%s\t", titl);
			for( i = i0, cnt = 0; i < n && cnt < 20; ++i, ++cnt ) {
				Dprintf( " %d", v[i] );
			}
			Dprintf( "\n");
		}
	} else {
		for( i0 = 0; i0 < n; i0 = i ) {
			Dprintf( "%s\t", titl);
			for( i = i0, cnt = 0; i < n && cnt < 20; ++i, ++cnt ) {
				Dprintf( " %d", v[i] );
			}
			Dprintf( "\n");
		}
	}
	return 0;
}
/*	ID_lrand48	(0,0x7fffffff)Ԃ̈li@j
/*******************************************************************/
static unsigned long   X[3] = { 0x5555, 0x5555, 0x5555 }; /* l */
static unsigned short  A[3] = { 0x0005, 0xDEEC, 0xE66D }; /* 搔l */
static unsigned short  C[3] = { 0x0000, 0x0000, 0x000B }; /* l */
long lrand48() /* NT031022add */
{
    unsigned long 	lrc;
	register unsigned long	z0, z1, z2, *xx = X, smask = 0xffff; /*, smask = 0x7fffffff;*/
	register unsigned short  *aa = A;
    do {
    	z2  = xx[2]*aa[2] + C[2];
		z1  = (z2 >> 16) + xx[2]*aa[1] + xx[1]*aa[2];
	    z0  = (z1 >> 16) + xx[0]*aa[2] + xx[1]*aa[1] + xx[2]*aa[0];
		xx[2] = z2 & smask;
		xx[1] = z1 & smask;
		xx[0] = z0 & smask;
        lrc = (xx[1] << 16) + xx[2];
    } while( lrc == 0xFFFFFFFF );
    return( lrc & 0x7FFFFFFF );
}
/**********************************************/
/* {xZ@
/* 2001.05.23 Y.Shibasaki
/**********************************************/
/*#include <stdio.h> */
/*#include <string.h> */
#include <math.h>
static int		dbg = 0;

/* _𕪊 */
static int
bunnkatu(
	double	S  ,        /* ̐ */
	double	*S1,
	double	*S2)        /* ʕAʕ */
{
	double	sift_S,ANS;

	sift_S = S * pow(2.0,27.0);
	/* 擪QTrbg̎肾 */
	*S1 = ANS = (S + sift_S) - sift_S;
	/* ʂQVrbg̎肾 */
	*S2 = S - ANS;
/*	if(dbg) Dprintf("S(%0.17e) *S1(%0.17e) *S2(%0.17e)\n",S,*S1,*S2); /* */
	return(0);
}

/* {x̊|Z */
int
bai_seki(
	double	*s,            /* ̐ {xʕ */
	double	*r,            /* ̐ {xʕ */
	double	a )            /* |鐔 */
{ 
	double		s1,s2,r1,r2,a1,a2;
	double		ans1,ans2;

	/* s  s1 s2 ɕ */
	bunnkatu(*s,&s1,&s2);
	/* r  r1 r2 ɕ */
	bunnkatu(*r,&r1,&r2);
/*	if(dbg) Dprintf("s(%0.17e) s1(%0.17e) s2(%0.17e) r(%0.17e) r1(%0.17e) r2(%0.17e) \n"
		,*s,s1,s2,*r,r1,r2);  /* */
	/* a  a1 a2 ɕ */
	bunnkatu(a,&a1,&a2);

	/* ̔{xʕ s1 * a1  */
	ans1 = s1 * a1;
	/* ̔{xʕ s2 * a1  */
	ans2 = s2 * a1;
/*	if(dbg) Dprintf("1)ans1(%0.17e) ans2(%0.17e) \n",ans1,ans2); /* */
	/* ̔{xʕ s1 * a2 Z */
	ans2 += s1 * a2;
/*	if(dbg) Dprintf("2)ans1(%0.17e) ans2(%0.17e) \n",ans1,ans2); /* */
	/* ̔{xʕ s2 * a2 Z */
	ans2 += s2 * a2;
/*	if(dbg) Dprintf("3)ans1(%0.17e) ans2(%0.17e) \n",ans1,ans2); /* */

	/* ̔{xʕ r1 * a1 Z */
	ans2 += r1 * a1;
/*	if(dbg) Dprintf("4)ans1(%0.17e) ans2(%0.17e) \n",ans1,ans2); /* */
	/* ̔{xʕ r1 * a2 Z */
	ans2 += r1 * a2;
/*	if(dbg) Dprintf("5)ans1(%0.17e) ans2(%0.17e) \n",ans1,ans2); /* */
	/* ̔{xʕ r2 * a1 Z */
	ans2 += r2 * a1;
/*	if(dbg) Dprintf("6)ans1(%0.17e) ans2(%0.17e) \n",ans1,ans2); /* */
	/* ̔{xʕ r2 * a2 Z */
	ans2 += r2 * a2;
/*	if(dbg) Dprintf("7)ans1(%0.17e) ans2(%0.17e) \n",ans1,ans2); /* */
	*s = ans1;
	*r = ans2;
	return(0);
}

/* 
 * FILE     : dprintf.c
 * AUTHOR   : N.Tsuchiya 1999.06.23
 * SYSTEM   : nVXeWCu
 * FUNCTION : 
 * PROTTYPES:
	int dbgfilename(char *fname);
	int Dclose();
	int Dprintf( char *Fmt, ... );
 * gp@
dbgfilename(char *fname)
    o̓t@Cfnameɐݒ܂͕ύXB
	fnameNULL܂""܂dbgfilename()Ă΂ȂƂ͕Wo͂ɏo͂
	Wo(stdout)`̂Ƃfname="dprintf.dbg"ɏo͂
	Ȍo̓t@CfcloseāAVɃt@Cfname̐擪o͂JnB
Dclose()
	t@C̃N[Y
Dprintf( char *Fmt, ... )
	printf()Ɠl
*/

#if 1 || !defined(Dprintf) //NT040113add 1 ||

#include	<stdarg.h>    /* MSVC, MSVC++, HP-UX CC, HP-UX cc -Aa */
static int	fclose_every_time = 1; /* Win3.1 Win95 MSDOSł͂Pǂ */
static char *s_dbgfn = ""; /*  */
static FILE	*s_dfp = NULL;
static int 	second = 0;

/* ID_dbgopen t@CI[v
/********************************************************************/
static int dbgopen( char *mode )
{
	if( s_dfp ) return 0;
#if defined(stdout)
	if( s_dbgfn[0] == '\0' ) s_dfp = stdout;
	else                     s_dfp = fopen( s_dbgfn, mode );
#else  /* DLLŕWostdoutgȂƂ */
	if( s_dbgfn[0] == '\0' ) s_dbgfn = "dprintf.dbg";
	s_dfp = fopen( s_dbgfn, mode );
#endif
	return( (s_dfp == NULL) ? -1 : 0 );
}
/* ID_dbgclose t@C̃N[Y
/********************************************************************/
static int dbgclose()
{
#if defined(stdout)
	if( s_dfp && s_dfp != stdout ) { fclose( s_dfp ); s_dfp = NULL; }
#else  /* DLLŕWostdoutgȂƂ */
	if( s_dfp  ) { fclose( s_dfp ); s_dfp = NULL; }
#endif
	return(0);
}
/* ID_Dchange_dbgfn t@C̕ύX
/********************************************************************/
int Dchange_dbgfn(char *fname)
{
	if( fname == NULL ) s_dbgfn = "";
	else                s_dbgfn = fname;
	return 0;
}
/* ID_Dopen t@CI[v
/********************************************************************/
int lp_Dopen(char *fname)
{
	int		rc;
	dbgclose();
	if( s_dbgfn[0] == '\0' )   /* NT030227 add */
		s_dbgfn = fname;
	if( fname == NULL ) s_dbgfn = "";
	if( second ) rc = dbgopen( "a" );
	else         rc = dbgopen( "w" );
	if( rc >= 0 ) second = 1;
	else          s_dbgfn = "";
	return( rc );
}
/* ID_Dclose t@C̃N[Y
/********************************************************************/
int lp_Dclose()
{
	dbgclose();
	second = 0;
	return(0);
}
/* ID_Dstdout_end Wo͂̏ꍇ݂̂̃Zbg
/********************************************************************/
int lp_Dstdout_end(void)
{
	if( s_dfp == stdout ) {
		second = 0;
		s_dfp = NULL;
	}
	return(0);
}
/* ID_Dprintf t@Cւ̃vg(vprintf)
/********************************************************************/
int lp_Dprintf( char *lpszFormat, ... )
{
	int		rc;
	va_list args;
	va_start(args, lpszFormat);

	if( s_dfp == NULL ) dbgopen( "a" );
	if( s_dfp == NULL ) return( 0 );
	rc = vfprintf( s_dfp, lpszFormat, args ) ;
	va_end( args ) ;
	if( fclose_every_time ) dbgclose();
	else                    fflush(s_dfp);
	return( rc ) ;
}
#  if 1 || defined _DEBUG_SSC
/* ID_Eprintf t@Cւ̃vg(vprintf)
/********************************************************************/
int lp_Eprintf( char *lpszFormat, ... )
{
	int		rc;
	va_list args;
	va_start(args, lpszFormat);

	if( s_dfp == NULL ) dbgopen( "a" );
	if( s_dfp == NULL ) return( 0 );
	rc = vfprintf( s_dfp, lpszFormat, args ) ;
	va_end( args ) ;
	if( fclose_every_time ) dbgclose();
	else                    fflush(s_dfp);
	return( rc ) ;
}
#  else
int lp_Eprintf( char *lpszFormat, ... )
{
	return( 0 ) ;
}
#  endif
/* ID_dummy_printf t@Cւ̃vg(vprintf)
/********************************************************************/
int dummy_printf_UNUSED( char *lpszFormat, ... )
{
	return( 0 ) ;
}

#endif		/* Dprintf */
