/*
 * FILE      : lptest.c
 * SYSTEM    : ktAό`Atsgđ^ako
 * FUNCTION  : beXgphCo[
 * AUTHOR    : N.Tsuchiya  2000.02.28
 */
static char	*__file =__FILE__;  /* should be copied into all .c files   */
#include <string.h>
#define EXTERN
#include "lufact_uif.h"
#include "lp_ssc.h"
#include "lpvect3.h"
#include "lplufact.h"

/*	ID_lu_renew	kts̗̈𐶐
*******************************************************************/
void *lu_new()
{
	LUFACT *lu = new LUFACT;
	memset( lu, 0, sizeof(LUFACT) );
	lp_Dopen("LUfactdbg.txt");
	lpdbgf[99] = 2;
	lpdbgf[250] = 2;
	return lu;
}
/*	ID_lu_resize	kts̗̈mۂƏ
*******************************************************************/
int lu_resize( void *lu,int sz )
{
	int x_br = 0, rc;
	double r_av = 0.01;
	rc = lumx_renew( (LUFACT*)lu, sz, x_br, r_av ); CHKB(0, rc, 0);
	if( sz > 20 ) lpdbgf[250] = 0;
	return rc;
}
/*	ID_lu_append	ktšWz̖ɒǉB(s,)Qȏǉƌʂ͕ۏ؂Ȃ
*******************************************************************/
int lu_append( void *lu, int row, int col, double v)
{
	int rc = lumx_append( ((LUFACT*)lu)->lu, row, col, v); CHKA(0, rc, ((LUFACT*)lu)->lu->n_av);
	return rc;
}


/*	ID_lu_factoring	ktts쐬
*******************************************************************/
int lu_factoring( void *lu,  /* SUHLv(?)ORSA J.C. Vol2-4 1990 PP325-335 fill-in팸kt */
	int	inperfect,     /* 1:sS[h b_var[]<0LBϐȂƂɎg */
	int *rank,         /*  o */
	int **order,       /*  o ʂ̃f[^Yorder[i] */
	int **revord)      /*  o f[^̏ʂrevord[i] */
{
	int rc = lu_factorization( (LUFACT*)lu, inperfect, rank, order, revord); CHKB(0, rc, 0);
	return rc;
}

/*	ID_lu_kakunin	kttšZ
*******************************************************************/
int lu_kakunin( void *lu )
{
	int rc = lu_kenzan( (LUFACT*)lu ); CHKB(0, rc, 0);
	return rc;
}
/*	ID_lu_delete	ktts̗̈J
*******************************************************************/
void lu_delete(void *lu)
{
	lu_free(&lplu);
	lumx_free( (LUFACT*)lu );
	delete (LUFACT*)lu;
	return;
}
/*	ID_lu_ftran	ϊBinv(a)~̌vZ
*******************************************************************/
int lu_ftran(
	void *lu,   //i
	double *vo, //o
	double *vi) //i
{
	int rc;
#if 1
	memcpy(vo, vi, sizeof(double) * ((LUFACT*)lu)->lu->n_col);
	rc = lu_ftran_d1( (LUFACT*)lu, vo  );
	rc = lu_ftran_d2( (LUFACT*)lu, vo  );
#else
	VECT2 v2;
	v2.x_elem = 0;
	lpvect2_alloc( &v2, ((LUFACT*)lu)->lu->n_col, 0 );
	lpvect2_reset( &v2);
	memcpy(v2.va, vi, sizeof(double) * ((LUFACT*)lu)->lu->n_col);
	lpvect2_make_link( &v2 );
	rc = lu_ftran_v21( (LUFACT*)lu, &v2  );
	rc = lu_ftran_v22( (LUFACT*)lu, &v2  );

#endif
	return rc;
}
/*	ID_lu_btran	tϊB΁΁~invťvZ
*******************************************************************/
int lu_btran(
	void *lu,    //i
	double *vo,  //o
	double *vi)  //i
{
	int rc;
	memcpy(vo, vi, sizeof(double) * ((LUFACT*)lu)->lu->n_col);
	rc = lu_btran_d1( (LUFACT*)lu, vo, -1  );
	rc = lu_btran_d2( (LUFACT*)lu, vo  );
	return rc;
}
/*	ID_lumx_mult_mx_d	sƃxNg̊|ZBuoa~ui
/*******************************************************************/
int lu_mult_mx_d( // 0:@1:WsێĂȂ
	void *lu,     //i
	double *vo,   //o
	double *vi)   //i
{
	int rc = 0;
	if( ((LUFACT*)lu)->bs != 0 ) {
		lumx_mult_mx_d( ((LUFACT*)lu)->bs, vo, vi );
	} else {
		memset( vo, 0, sizeof(double) * ((LUFACT*)lu)->sz );
		rc = 1;
	}
	return rc;
}
/*	ID_lu_mult_d_mx	xNgƍs̊|ZBuoui~`
/*******************************************************************/
int lu_mult_d_mx(  // 0:@1:WsێĂȂ
	void *lu,      //i
	double *vo,    //o
	double *vi)    //i
{
	int rc = 0;
	if( ((LUFACT*)lu)->bs != 0 ) {
		lumx_mult_d_mx( ((LUFACT*)lu)->bs, vo, vi );
	} else {
		memset( vo, 0, sizeof(double) * ((LUFACT*)lu)->sz );
		rc = 1;
	}
	return rc;
}
