/*
 * FILE      : lutest.c
 * SYSTEM    : ktAό`Atsgđ^ako
 * FUNCTION  : beXgphCo[
 * AUTHOR    : N.Tsuchiya  2000.02.28
 */
#include <stdlib.h>  //rand
#include <vector>
#include <time.h>
#pragma warning(disable:4996) //wb_[ɓƏoȂȂB.Net2005
#pragma warning(disable:4018) //wb_[ɓƏoȂȂB.Net2005
using namespace std;
#include "lufact_uif.h"

struct AIJ {
	int i, j;
	double a;
};
/*	ID_p1	
/*******************************************************************/
static int p1(
	 int *sz,             //o
	 int *nz,             //o
	 vector<AIJ> *vecAij, //o
	 vector<double> *v)   //o
{
	int rc, k;
	AIJ aij;
//	double a1[] = { 1, 0, 0, 0, 1, 0, 0, 0, 1 };
	double a2[] = { 0, 2, 3,-2, 0,-4, 2, 2, 4 }; //inv={-0.67, 0.17. 0.67, 0, 0.5, 0.5, 0.33, -0.33, -0.33} ips1=ips2={2,0,1}
	double a3[] = { 3, 0, 2,-4,-2, 0, 4, 2, 2 }; //inv={0.33, -0.33, -0.33, -0.67, 0.17. 0.67, 0, 0.5, 0.5} ւ
	double aa[] = { 0, 2, 3, 2, 2, 4,-2, 0,-4 }; //inv={-0.67, 0.17. 0.67, 0, 0.5, 0.5, 0.33, -0.33, -0.33} ips1=ips2={2,0,1}
	double vi[] = {1, 2, 3};
	vecAij->clear();
	*nz = sizeof(aa) / sizeof(double);
	*sz = sizeof(vi) / sizeof(double);
	v->resize(*sz);
	for( k = 0; k < *nz; ++k ) {
		if( aa[k] == 0.0 ) continue;
		aij.i = k / *sz;
		aij.j = k % *sz;
		aij.a = aa[k];
		vecAij->push_back(aij);
	}
	*nz = vecAij->size();
	for( k = 0; k < *sz; ++k ) {
		(*v)[k] = vi[k];
	}
	rc = 0;
	return rc;
}
/*	ID_compAij	
/*******************************************************************/
static int compAij(AIJ *p, AIJ *q)
{
	int rc = p->i - q->i;
	if( rc == 0 )
		rc = p->j - q->j;
	return rc;
}
/*	ID_unique_aij	
/*******************************************************************/
static int unique_aij(vector<AIJ> &vecAij)
{
	int i, j;
	qsort(&vecAij[0], vecAij.size(), sizeof(AIJ), (int(*)(const void*,const void*))compAij);
	for( i = j = 0; i < vecAij.size() && j < vecAij.size(); ++i, ++j ) {
		if( i != j ) vecAij[i] = vecAij[j];
		//(i,j)XLbv
		for( ; j < vecAij.size() - 1; ++j ) {
			if( compAij(&vecAij[j], &vecAij[j+1]) != 0 ) break;
		}
	}
	vecAij.resize(i);
	return i;
}

/*	ID_p2	
/*******************************************************************/
static int p2(
	int sz,              //i   Aꎟ̃TCYBs()
	int *nz,             //io  Ő(i,j)瓯̂폜̂ŏ
	vector<AIJ> *vecAij, //o   ašW(i,j,aij)̔z
	vector<double> *v)   //o   Aꎟ̉EӃxNg
{
	int rc, k;
	AIJ aij;
	vecAij->clear();
	v->resize(sz);
	for( k = 0; k < sz; ++k ) {
		(*v)[k] = rand() / (double)RAND_MAX * 100;;
		/* mۂ邽߂ɑ̊ivfPɂ */
		aij.i = aij.j = k;
		aij.a = 1.0;
		vecAij->push_back(aij);
	}
	for( k = 0; k < *nz; ++k ) {
		aij.i = (int)(rand() / (double)RAND_MAX * sz);
		aij.j = (int)(rand() / (double)RAND_MAX * sz);
		if( aij.i >= sz ) aij.i = sz - 1;
		if( aij.j >= sz ) aij.j = sz - 1;
		aij.a = rand() / (double)RAND_MAX * 100;
		vecAij->push_back(aij);
	}
	*nz = unique_aij(*vecAij);
	rc = 0;
	return rc;
}
/*	ID_mult_mx_d	sƃxNg̊|ZBuoa~ui
/*******************************************************************/
static int mult_mx_d(
	int sz,       //i
	int nz,       //i
	AIJ *aij,     //i
	double *vo,   //o
	double *vi)   //i
{
	int i, j, k;
	memset( vo, 0, sizeof(double) * sz );
	for( k = 0; k < nz; ++k ) {
		i = aij[k].i;
		j = aij[k].j;
		vo[i] += vi[j] * aij[k].a;
	}
	return 0;
}
/*	ID_mult_d_mx	xNgƍs̊|ZBuoui~`
/*******************************************************************/
static int mult_d_mx(
	int sz,       //i
	int nz,       //i
	AIJ *aij,     //i
	double *vo,   //o
	double *vi)   //i
{
	int i, j, k;
	memset( vo, 0, sizeof(double) * sz );
	for( k = 0; k < nz; ++k ) {
		i = aij[k].i;
		j = aij[k].j;
		vo[j] += vi[i] * aij[k].a;
	}
	return 0;
}
/*	ID_lu_test1_calc	
/*******************************************************************/
static int lu_test1_calc(
	void *lu, int sz, int nz, vector<AIJ> &vecAij, vector<double> &v,
	int dbgf)
{
	int rc, k, rank, *order, *weight;
	double epsi = 1e-6;
	vector<double> r1, r2;
	r1.resize(sz);
	r2.resize(sz);
	/* kts̗̈mۂƏ */
	rc = lu_resize( lu, sz );
	if( rc < 0 ) goto                                                  quit;
	for( k = 0; k < nz; ++k ) {
		/* ktšWz̖ɒǉB(s,)Qȏǉƌʂ͕ۏ؂Ȃ */
		rc = lu_append( lu, vecAij[k].i, vecAij[k].j, vecAij[k].a);  // 0<=rc< nz+sz
	}
	/* kt*/
	rc = lu_factoring(lu, 0, &rank, &order, &weight);
	if( (rc = sz - rank) != 0 ) goto                                    err1;
//	/* kťZ */
//	if( dbgf )rc = lu_kenzan( lu );
	/* ϊBinv(a)~̌vZ */
	rc = lu_ftran(lu, &r1[0], &v[0]);
	if( dbgf ) {
		/* sƃxNg̊|ZBuoa~ui */
		rc = mult_mx_d( sz, nz, &vecAij[0], &r2[0], &r1[0] );
		if( rc == 0 ) {
			for( k = 0; k < sz; ++k ) {
				if( v[k] - epsi > r2[k] || r2[k] > v[k] + epsi ) {
					printf("ftran k(%d) v(%e) ans(%e) err(%e)\n", k, v[k], r1[k], v[k] - r2[k]);
				}
			}fflush(stdout);
		}
	}
	/* tϊB΁΁~invťvZ */
	rc = lu_btran(lu, &r1[0], &v[0]);
	if( dbgf ) {
		/* xNgƍs̊|ZBuoui~` */
		rc = mult_d_mx( sz, nz, &vecAij[0], &r2[0], &r1[0] );
		if( rc == 0 ) {
			for( k = 0; k < sz; ++k ) {
				if( v[k] - epsi > r2[k] || r2[k] > v[k] + epsi ) {
					printf("btran k(%d) v(%e) ans(%e) err(%e)\n", k, v[k], r1[k], v[k] - r2[k]);
				}
			}fflush(stdout);
		}
	}
	rc = 0;
quit:
	return rc;
err1:
	printf("Ns@size = %d, rank = %d\n", sz, rank );
	goto                                                                quit;
}
/*	ID_lu_test1	
/*******************************************************************/
static int lu_test1(void *lu)
{
	int k, sz, rc, nz;
	vector<AIJ> vecAij;
	vector<double> v;
	for( k = 0; k < 10; ++k ) {
		if( 0 ) {
			rc = p1( &sz, &nz, &vecAij, &v);
		} else {
			sz = 5; nz = sz * 3;
			rc = p2( sz, &nz, &vecAij, &v);
		}
		rc = lu_test1_calc(lu, sz, nz, vecAij, v, 1);
	}
	return rc;
}
static int lu_test2(void *lu)
{
	int rc, k, d, sz, nz, dbgf = 0;
	vector<AIJ> vecAij;
	vector<double> v;
	clock_t	ck1, ck2;   /*  */
#ifdef _DEBUG_SSC
	dbgf = 1;
#endif
	ck1 = clock() ;
#if 1
	sz = 1000;
	for( d = 3; d < 10; ++d ) {
		for( k = 0; k < 1; ++k ) {
			nz = sz * d;
			rc = p2( sz, &nz, &vecAij, &v);
			rc = lu_test1_calc(lu, sz, nz, vecAij, v, dbgf);
			ck2 = ck1; ck1 = clock() ;
			printf("sz = %d nz = %d rc = %d clock = %.2f\n", sz, nz, rc, (ck1 - ck2) / (double)CLOCKS_PER_SEC );
		}
	}
#endif
#if 0
	sz = 1000;
	for( d = 10; d < 100; d += 10 ) {
		for( k = 0; k < 1; ++k ) {
			nz = sz * d;
			rc = p2( sz, &nz, &vecAij, &v);
			rc = lu_test1_calc(lu, sz, nz, vecAij, v, dbgf);
			ck2 = ck1; ck1 = clock() ;
			printf("sz = %d nz = %d rc = %d clock = %.2f\n", sz, nz, rc, (ck1 - ck2) / (double)CLOCKS_PER_SEC );
		}
	}
#endif
#if 0
	sz = 1000;
	d = 10;
	for( sz = 1000; sz < 100000; sz *= 2 ) {
//	for( sz = 8000; sz < 100000; sz *= 2 ) {
			nz = sz * d;
			rc = p2( sz, &nz, &vecAij, &v);
			rc = lu_test1_calc(lu, sz, nz, vecAij, v, dbgf);
			ck2 = ck1; ck1 = clock() ;
			printf("sz = %d nz = %d rc = %d clock = %.2f\n", sz, nz, rc, (ck1 - ck2) / (double)CLOCKS_PER_SEC );
	}
#endif
	return rc;
}

/*	ID_main	
/*******************************************************************/
int main()
{
	int rc;
	void *lu;
	//kts̗̈𐶐
	lu = lu_new();
	//eXgs
	rc = lu_test1(lu);
	rc = lu_test2(lu);
	//ktts̗̈J
	lu_delete(lu);
printf("press enter key\n"); fflush(stdout);
scanf("%c", &rc);
	return 0;
}

