/*
 * FILE      : lp_ve.c
 * SYSTEM    : ktAό`Atsgđ^ako
 * FUNCTION  : xNg̊evZȂ
 * AUTHOR    : N.Tsuchiya  2000.02.28
 */
static char	*__file =__FILE__;  /* should be copied into all .c files   */
#include <stdio.h>
#include <stdlib.h>
#include <memory.h>
//#include "lp_uif.h"
#include "lp_ssc.h"
#include "lpvect3.h"
/*	ID_exp_vobject	double^ẑPvfm
/********************************************************************/
int exp_vobject( VOBJECT *vv, int num)
{
	int		rc;

	if( vv->x <= 0 ) {
		vv->x = 100;
		if( vv->x < num ) vv->x = num;
		if( NULL == (vv->v = (double*)malloc(vv->x * sizeof(double) )) ) goto erra;
	} else if( num > vv->x ) {
		vv->x = vv->x * 2;
		if( vv->x < num ) vv->x = num;
		if( NULL == (Realloc((void**)&vv->v, vv->x * sizeof(double) )) ) goto erra;
	}
	rc = vv->x;
quit:
	return rc;
erra:
	Eprintf( "**** exp_vobject: cannot malloc\n" );
	rc = MALLOC_ERROR; /* ߂l̕ύX 2000.09.28 K.Igarashi */
	goto                                                                quit;
}
/*	ID_new_vdouble	double^ẑPvfm
/********************************************************************/
int new_vobject( VOBJECT *vv)
{
	int		rc;
	if( vv->n >= vv->x )
		if( (rc = exp_vobject( vv, vv->n + 1)) < 0 ) goto                      quit;
	rc = (vv->n)++;                    CHKB(1, vv->n, vv->x);
	vv->v[rc] = 0.0;
quit:
	return rc;
}
/*	ID_free_vdouble	double^ẑPvfm
/********************************************************************/
void free_vobject( VOBJECT *vv)
{
	if( vv->x > 0 ) SSCFREE(vv->v);
	vv->x = 0;
	return ;
}

/*	ID_lpvect1_free	O|C^tdoublez̗̈̊JB
/********************************************************************/
int lpvect1_free( VECT1 *vect )
{
	SSCFREE(vect->va);
	SSCFREE(vect->next);
	memset( vect, 0, sizeof(*vect) );
	return 0;
}

/*	ID_lpvect1_alloc	O|C^tdoublez̗̈̊m
/********************************************************************/
int lpvect1_alloc( VECT1 *vect, int num )
{
	int		i, rc = 0, old_x_elem;
	old_x_elem = vect->x_elem;
	vect->n_elem = num++;  /* KvP]Ɋm */
	if( vect->x_elem <= 0 ) {
		if( NULL == (vect->va=(double*)malloc( num * sizeof(double))) ) goto erra;
		if( NULL == (vect->next =(int*)malloc( num * sizeof(int))) ) goto erra;
		vect->x_elem = num;
	} else if( vect->x_elem < num ) {
		if( NULL == (Realloc((void**)&vect->va, num * sizeof(double))) ) goto erra;
		if( NULL == (Realloc((void**)&vect->next, num * sizeof(int))) ) goto erra;
		vect->x_elem = num;
	}
	vect->top = -1;
	for( i = 0; i < vect->x_elem; ++i )
		vect->next[i] = -2;                        /* ǉ */
quit:
	return rc;
erra:
	Eprintf( "**** lpvect1_alloc: cannot malloc\n" );
	rc = MALLOC_ERROR; /* ߂l̕ύX 2000.09.28 K.Igarashi */
	goto                                                       quit;
}
/*	ID_lpvect1c_reset	O|C^tzNA
/*******************************************************************/
int lpvect1c_reset( VECT1c *vect )
{
	int		i;
	for( i = 0; i < vect->x_elem; ++i ) {
		vect->next[i] = -2;                        /* ǉ */
		vect->va[i] = 0;
	}
	vect->top = -1;
	return 0;
}
/*	ID_lpvect1_free	O|C^tdoublez̗̈̊JB
/********************************************************************/
int lpvect1c_free( VECT1c *vect )
{
	SSCFREE(vect->va);
	SSCFREE(vect->next);
	memset( vect, 0, sizeof(*vect) );
	return 0;
}

/*	ID_lpvect1_alloc	O|C^tdoublez̗̈̊m
/********************************************************************/
int lpvect1c_alloc( VECT1c *vect, int num )
{
	int		rc = 0, old_x_elem;
	old_x_elem = vect->x_elem;
	vect->n_elem = num++;  /* KvP]Ɋm */
	if( vect->x_elem <= 0 ) {
		if( NULL == (vect->va  =(char*)malloc( num * sizeof(char))) ) goto erra;
		if( NULL == (vect->next =(int*)malloc( num * sizeof(int))) ) goto erra;
		vect->x_elem = num;
	} else if( vect->x_elem < num ) {
		if( NULL == (Realloc((void**)&vect->va, num * sizeof(char))) ) goto erra;
		if( NULL == (Realloc((void**)&vect->next, num * sizeof(int))) ) goto erra;
		vect->x_elem = num;
	}
quit:
	return rc;
erra:
	Eprintf( "**** lpvect1_alloc: cannot malloc\n" );
	rc = MALLOC_ERROR; /* ߂l̕ύX 2000.09.28 K.Igarashi */
	goto                                                       quit;
}

/*	ID_lpvect2_reset	O|C^tzNA
/*******************************************************************/
int lpvect2_reset( VECT2 *vect )
{
	if( vect->nowf > 999999999 ) {
		vect->nowf = 0;
		memset( vect->usef, 0, vect->x_elem * sizeof(int) );
	}
	++vect->nowf;
	vect->top = -1;
/*	vect->nz  = 0; NT020508 del */
	return vect->nowf;
}
/*	ID_lpvect2_free	O|C^tz̊J
/*******************************************************************/
int lpvect2_free( VECT2 *vect )
{
	if( vect == NULL ) goto                                     quit;
	SSCFREE( vect->next );
	SSCFREE( vect->usef );
   	if( vect->e_alloc_flag ) /* 0:͏ʂŊmۍς 1:vect3Ŋmۋyfree */
		SSCFREE( vect->va );
	vect->x_elem = vect->n_elem = 0;
quit:
	return 0;
}
/*	ID_lpvect2_alloc	O|C^tz̊mہAgƏ
/*******************************************************************/
int lpvect2_alloc( VECT2 *vect, int num,
	double *pe )  /* vect->v̊mۂ NULL; !=NULL:ʂŎOɍs */
{
	int		i, rc = 0, old_x_elem;
	int		size; //NT050207add for 64bit int NT050113
	size = sizeof(*vect->va);  //NT050207add for 64bit int NT050113
	if( size < sizeof(*vect->pa) ) size = sizeof(*vect->pa);  //NT050207add for 64bit int NT050113
	old_x_elem = vect->x_elem;
	vect->n_elem = num++;  /* KvP]Ɋm */
	if( vect->x_elem <= 0 ) {
		if( NULL==(vect->next = (int*)malloc( num * sizeof(int))) ) goto erra;
		if( NULL==(vect->usef = (int*)malloc( num * sizeof(int))) ) goto erra;
		if( pe == NULL ) {
//			if( NULL==(vect->va = (double*)malloc(num * sizeof(*vect->va)))) goto erra;
			if( NULL==(vect->va = (double*)malloc(num * size))) goto erra; //NT050207chg for 64bit int NT050113
		   	vect->e_alloc_flag = 1; /* 0:͏ʂŊmۍς 1:vect3Ŋmۋyfree */
		} else {
/*			vect->v = (union vect2_val_u*)pe; /* 0:͏ʂŊmۍς 1:vect3Ŋmۋyfree */
		   	vect->e_alloc_flag = 0;
		}
		vect->x_elem = num;
	} else if( vect->x_elem < num ) {
		if( NULL==(Realloc((void**)&vect->next, num* sizeof(int))) ) goto erra;
		if( NULL==(Realloc((void**)&vect->usef, num* sizeof(int))) ) goto erra;
		if( pe == NULL ) {
			if( NULL==(Realloc((void**)&vect->va, num* size))) goto erra; //NT050207chg for 64bit int NT050113
		   	vect->e_alloc_flag = 1; /* 0:͏ʂŊmۍς 1:vect3Ŋmۋyfree */
		} else {
/*			vect->v = (union vect2_val_u*)pe; oO KȂ΂ȂȂ NT020222 */
		   	vect->e_alloc_flag = 0;
		}
		vect->x_elem = num;
	}
	if( pe != NULL ) vect->va = pe; /* NT020222 add */
	vect->pa = (TYPE2*)vect->va;                   /* NT021203 add */
	for( i = old_x_elem; i < vect->x_elem; ++i )
		vect->usef[i] = 0;                        /* ǉ */
	if( old_x_elem <= 0 ) vect->nowf = 0;         /* nowf͐̂ݏ */
quit: 
	return(rc);
erra:
	Eprintf( "**** lpvect2_alloc: cannot malloc\n" );
	rc = MALLOC_ERROR;
	goto                                                       quit;
}
/*	ID_lpvect2_clean	O|C^tz񂩂Ovf݂̂
/*******************************************************************/
int lpvect2_clean( VECT2 *vect )
{
	int rc = 0, i, pred = -1;
	for( i = vect->top; i >= 0; i = vect->next[i] ) {
		if( vect->va[i] != 0.0 ) { pred = i;
		} else { ++rc;
			vect->usef[i] = 0;
			if( pred < 0 ) { vect->top = vect->next[i];
			} else {  vect->next[pred] = vect->next[i];
			}
		}
	}
	return rc;
}
/*	ID_lpvect2_copy	O|C^tzRs[
/*******************************************************************/
int lpvect2_copy( VECT2 *to, VECT2 *fr )
{
	int rc = 0, i;
		                        CHKB(fr->n_elem, to->n_elem, fr->n_elem);
	lpvect2_reset( to);
	to->top = fr->top;
	for( i = fr->top; i >= 0; i = fr->next[i] ) {
		to->va[i] = fr->va[i];
		to->next[i] = fr->next[i];
		to->usef[i] = to->nowf;
	}
	return rc;
}
/*	ID_lpvect2_make_link	O|C^tz񂩂Ovf폜
/*******************************************************************/
int lpvect2_make_link( VECT2 *vect )
{
	int rc = 0, col;
	double	*pwk;
	vect->top = -1;
	pwk = vect->va;
	for( col = 0; col < vect->n_elem; ++col ) {
		if( pwk[col] != 0.0 ) {
			++rc;
			vect->usef[col] = vect->nowf;
			vect->next[col] = vect->top;
			vect->top = col;
		} else {
			vect->usef[col] = 0;
		}
	}
	return rc;
}
/*	ID_ssc_dump_double	z̉`_v
/*******************************************************************/
int ssc_dump_vect2d( VECT2 *v, int n, char *titl, int mode )
{
	int		i, i0, cnt;

	if( v->top < 0 ) Dprintf( "%s\n", titl);
	for( i0 = v->top; i0 >= 0; i0 = i ) {
		Dprintf( "%s\t", titl);
		for( i = i0, cnt = 0; i >= 0 && cnt < 20; i = v->next[i], ++cnt ) {
			Dprintf( "[%d]%g", i, v->va[i] );
		}
		Dprintf( "\n");
	}
	return 0;
}
/*	ID_ssc_dump_vect2	z̉`_v
/*******************************************************************/
int ssc_dump_vect2( VECT2 *v, int n, char *titl, int mode )
{
	int		i, i0, cnt;

	for( i0 = 0; i0 < n; i0 = i ) {
		Dprintf( "%s\t", titl);
		for( i = i0, cnt = 0; i < n && cnt < 20; ++i, ++cnt ) {
			Dprintf( " %g", LPVECT2_GET(v, i) );
		}
		Dprintf( "\n");
	}
	return 0;
}

/*	ID_ve_make_wp_link	O|C^tdoublez̃N쐬
/*******************************************************************/
int ve_make_wp_link_UNUSED( register VECT1 *alpha, int m1 )
{
	int		rc = 0;
	register int	ei, top, n0num = 0;

	top = -1;
	for( ei = m1 - 1; ei >= 0; --ei ) {
		if( alpha->va[ei] == 0.0 ) continue;
		alpha->next[ei] = top;
		top = ei;
		++n0num;
	}
	alpha->top = top;
	return n0num;
}

/*	ID_v_dump_double	z̉`_v
/*******************************************************************/
int v_dump_double( double *v, int n, char *titl, int mode )
	{ return( ssc_dump_double( v, n, titl, mode ) );}
/*	ID_v_dump_int	z̉`_v
/*******************************************************************/
int v_dump_int( int *v, int n, char *titl, int mode )
	{ return(ssc_dump_int( v, n, titl, mode ) ); }

