/*
 * FILE      : lplufact.h
 * SYSTEM    :
 * FUNCTION  : P̖@Ŏg\́AϐA֐A}N̒`
 * REFERENCE : ×ї,1980,`v@,YƐ}
 * AUTHOR    : N.Tsuchiya  2000.02.28
 * SYNOPSIS  :
 */
#if ! defined(LPLUFACT_H)
#define LPLUFACT_H

#if ! defined(EXTERN)     /* lpsparse.ĉ݂EXTERN` */
#define EXTERN	extern
#endif

//#include "lpcommon.h"
//#define B3_USE

#define MAXPV	100 /* USEPV̉\őlBts̍ċt]^C~OBŕϊqq̍ő吔 */

#define AVTB_HEAD_MAX 10000
#define UNIT_NUM 0x10000
#define LUAV(mav, aa) (&mav.avtb[((unsigned int)(aa))>>16][((unsigned int)(aa)) & 0xffff])

struct LUAVS {       /* ktps̔Ovf(\) */
	int 	*i;        /* sԍB */
	int 	*j;        /* ԍB */
	int		*nexti;   /* (j)[s(i)(vZ)   av[]or-1 */
		              /* 擪col_headB                              */
	int		*nextj;   /* s(i)[(j)(vZ)   av[]or-1 */
		              /* 擪row_headB                              */
	double	*v;        /* s̒l */
};
/* Ɗs(ktO)Ŏg\ */
struct LUMATRX { /* ktp}gbNX̍\ */
	LUAVS	av;  /* ̌Ws̎́B */
	int 	n_av;      /* av[]̎gpvf */
	int 	n_col;     /*  Ws`̂Ƃ=m+n+1 sAkt̂Ƃ=m+1 */
	int 	n_row;     /* =m+1   s */
	int 	x_av;      /* mۗvf av[]p */
	int 	x_col;     /* mۗvf col_head[] col_tail[]p */
	int 	x_row;     /* mۗvf row_head[] row_tail[]p */
	int 	num_nz;    /* Ovf̐                    */
	int 	*col_nz;   /* [x_col] ̔Ovf̐                    */
	int		*col_head; /* [m+1] ̔O̐擪vf         av[]or-1 */
	int 	*row_nz;   /* [x_row] s̔Ovf̐                    */
	int		*row_head; /* [m+1] s̔O̐擪vf         av[]or-1 */
	/* MATRXɒǉo[ */
	int		*col_k_head; /* [m+1] ̔O̐擪Bktiks av[]or-1 */
	int		*row_k_head; /* [m+1] s̔O̐擪Bktiks av[]or-1 */
	double	*rmax_v;   /* [m+1] s̍őΒlBrowmax_f[]=0͖̎` NT010820 */
	int 	*rmax_f;   /* [m+1] s̍őΒlݒς݃tO             NT010820 */
	double	*cmax_v;   /* [m+1] ̍őΒlBrowmax_f[]=0͖̎` NT010820 */
	int 	*cmax_f;   /* [m+1] ̍őΒlݒς݃tO             NT010820 */
};
struct PFVECT {    /* pfv[] ό`̂P̗xNgB(q)ł͍sxNg */
	int 	dim;      /* orsԍ(0..m)Bbr̂Ƃ͌̍s̍sԍ */
	int		pf_head; /* dim̔O̐擪vfBbr̂Ƃdims擪 av[]or-1 */
	int 	allnext;     /* Ops̗̎B擪allbgnpfv,allbgnaux pfv[]or-1 */
	int 	allpred;     /* Ops̑O̗Ballendpfv,allendaux pfv[]or-1 */
	int 	usenext;     /* Ops̗̎B擪usebgnpfv,usebgnaux pfv[]or-1 */
	int 	usepred;     /* Ops̑O̗Buseendpfv,useendaux pfv[]or-1 */
/*	int		nz;       /* OvfBP̂Ƃ͑Ίpvf̂ݔÔ͂ */
};
struct PFVECT2 {    /* pfv[] ό`̂P̗xNgB(q)ł͍sxNg */
	int		pf_head; /* dim̔O̐擪vfBbr̂Ƃdims擪 av[]or-1 */
	int 	usenext;     /* Ops̗̎B擪usebgnpfv,usebgnaux pfv[]or-1 */
	int 	usepred;     /* Ops̑O̗Buseendpfv,useendaux pfv[]or-1 */
/*	int		nz;       /* OvfBP̂Ƃ͑Ίpvf̂ݔÔ͂ */
};

struct SANKAKU { /* ό`sWBkt̂kAtAŕϊqq */
	PFVECT	*pfv;     /*[m+1] Ops̗Bbr̂Ƃ͍s */
	PFVECT2	*aux;     /*[m+1] Ops̍sBbr̂Ƃ͗ */
	int 	typev;    /* 1:^(lw,up) 2:s^(br)  */
	int 	allbgnpfv;   /* Ops̐擪 Zێp            pfv[] */
	int 	allendpfv;   /* Ops̖ ̗SĊ܂          pfv[] */
	int 	usebgnpfv;   /* Ops̐擪 ftran btranp             pfv[] */
	int 	useendpfv;   /* Ops̖ ̗͏              pfv[] */
	int 	usebgnaux;   /* Ops̐擪s NT020605                  pfv[] */
	int 	useendaux;   /* Ops̖s                           pfv[] */
};              //sankaku_s
/* ts̍\ */
struct LUFACT {       /* sBtsAXp[XAkt`̕\B */
/*	struct pf_s	*pf;   /* xNg̔OvfBr̖gp̍ėp͂AŌɒǉ̂ */
	SANKAKU	br;        /* [MAXPV] ŕϊqBs^xNg */
	SANKAKU	lw;        /* [sz] OpsB^xNg */
	SANKAKU	up;        /* [sz] OpsB^xNg */
	LUMATRX	*lu;       /* Ώsz~szs񁕃[N */
	LUMATRX	*bs;       /* Ώsz~szs(a~a^~̃`FbNp) */
	double	*diag_v;     /* [sz] Ίpvf̒l */
	int 	n_br;      /* ŕϊqbr[]f[^ */
	int 	x_br;      /* n_br̉\őlBlpdbgf[13]ŐBőlMAXPV */
	int 	sz;        /* =m+1 s̑傫sz~sz */
	int 	x_sz;
	int 	*ips1;     /* [m+1] ktBk=ips1[i]:sԖڂɕ -1:łȂ */
	int 	*ips2;     /* [m+1] ktBk=ips2[j]:Ԗڂɕ */
/*	double	*scale;    /* [m+1] kt̂ƂȂIp */
	int		ll_nz;     /* ksOvf̐BΊpvf    */
	int		uu_nz;     /* tsOvf̐                   */
	int		lu_rfusoku; /* 0: >0:Ns <0:̈s̃G[ NT020401 */
};               //lufact_s

/* ubNOpŎg\ */
struct PAIR { /* pair[] match(i,j)̏ */
	int		row;       /* sԍ 0..m */
	int		col;       /* ԍ 0..m */
	int		ms;        /* matchW̔ԍ        ms[] */
	int		nextpair;  /* match        pair[]or-1 */
		               /* 擪ms[].toppair */
};                 // block_pair_s
struct MSET { /* ms[] matchW */
	int		sumi;      /* ubN 0:܂ 1:ς */
	int		toppair;   /* 擪matching       pair[] */
	int		nextms;    /* matchW        ms[]or-1 */
		               /* 擪b3[].topms */
};                 //match_set_s
struct BLOCK3 { /* b3[]   ubNRpŎg[N */
	int		topms;     /* 擪matchW            ms[] */
	int		numms;     /* matchW̐Bms[]̃f[^  */
	int		nums1;     /* TCYP̃ubN */
	MSET	*ms;       /* [m+1] matchW */
	PAIR	*pair;     /* [m+1] match(i,j)̏ */
	int		*list1;    /* [m+1] Z@|P̌ʂ̂h0           pair[]or-1 */
		               /* Rp͍s̏ubNԍ          NT010703 */
	int		*list2;    /* [m+1] Z@|P̌ʂ̂i0           pair[]or-1 */
		               /* Rp͗񂊂̏ubNԍ          NT010703 */
	int		*sumi1;    /* [m+1] slist1[]̗LtO */
	int		*sumi2;    /* [m+1] 񂊂list2[]̗LtO */
	int		*ips1;     /* [m+1] match(i,j)ips1[i]=j */
	int		*ips2;     /* [m+1] match(i,j)ips2[j]=i */
	int 	*frnd;     /* [m+1] ŝ̔O̐擪vf      av[]or-1 */
};               //block_3kaku_s
struct NZLST { /* Ovfꗗ YsԍɑΉ */
	int		nz;        /* Ovf                                        */
	int		next;      /* Ovf̍sA lplu.r_nzlst[] c_nzlst[]or-1 */
	                   /* 擪lplu.r_nztop[]Alplu.c_nztop[]              */
	int		pred;      /* OvfO̍sA lplu.r_nzlst[] c_nzlst[]or-1 */
};                //nz_lst_s

/* O[oϐ܂Ƃ߂\ */
struct lu_work_s {     /* [Nϐ̍\́B*/
	double	*dwk1;     /* [m+1][NB`FbNŎg                        */
	double	*dwk2;     /* [m+1][NB`FbNŎg                        */
	double	*dwk3;     /* [m+1][NB`FbNŎg                        */
	int		*ips1;     /* [m+1+2] srow̕Ԗlplu.ips1[row]Bkt̓[N*/
	int		*ips2;     /* [m+1+2] col̕Ԗlplu.ips1[row]Bkt̓[N*/
	VECT2	ur;        /* t^̂sڂ̉xNgBqŕϊq̂Ɏg */
	int		*aibo;     /* [m+1](1)}b`Ǒ (2)sJEgp[N     */
		               /*      (3)s̊ϐԍ -1: -2:݂Ȃ   */
	int		(*mt)[2];  /* [2m] }b`O()Ō߂ktŎgvf̃Xg */
		               /* [0]:s [1]:                                      */
	int		x_sz;     /* mt[]̊mۗvf */
	void	*c_heap;   /* q[vnh                                   */
	void	*r_heap;   /* sq[vnh                                   */
	VECT2	dalpha;    /* [NB                                           */
	int		*c_nztop;  /* [m+1]Ovf̐擪         lplu.c_nzlst[]or-1 */
	int		*r_nztop;  /* [m+1]sOvf̐擪         lplu.r_nzlst[]or-1 */
	NZLST	*c_nzlst;  /* [m+1]Ovfꗗ                              */
	NZLST	*r_nzlst;  /* [m+1]sOvfꗗ                              */
#if defined B3_USE
	BLOCK3	b3;        /* ubNRpŎg[N                         */
#endif //defined B3_USE
};
/*-------------- O[oϐ̐錾 --------------------------------------*/
EXTERN struct lu_work_s	lplu;       /* [Nϐ̍\́B*/

/*-------------- ֐̐錾 --------------------------------------*/
#if defined(__cplusplus) 
//1 extern "C" {
#endif
/* ts̗̈̉ */
int lu_free(struct lu_work_s *lplu);
/* s̗̈morg */
int lumx_free( LUFACT *w_a );
/* s̃_v */
int lumx_dump_all( LUMATRX *a, char *titl );
/* kAtAqs̏ */
int lu_reset( LUFACT *b );
/* ktO̍s̏ */
int lumx_reset( LUMATRX *a );  /* ύX HY020225 */
/* s̗̈mۂƊg */
int lumx_renew( LUFACT *b,int sz, int x_br, double r_av );
/* s̖ɒǉBsA񋤂ɖǉp */
int lumx_append( LUMATRX *a, int row, int col, double v);
/* sƃxNg̊|ZBuo`~ui*/
int lumx_mult_mx_d(LUMATRX *a, double *vo, double *vi );
int lumx_mult_mx_v2(LUMATRX *a, double *vo, VECT2 *vi );
/* aWsɒǉB */
/* int lumx_append2( LUMATRX *a, int row, int col, double v); */
int lumx_k_append2( LUMATRX *a, int row, int col, double v);
/* ktiks̍폜B*/
int lumx_k_rm_row_col( LUMATRX *a, int row,int col,int mode);
/* sƃxNg̊|ZBuoui~`*/
int lumx_mult_d_mx(LUMATRX *a, double *vo, double *vi );
int lumx_mult_v2_mx(LUMATRX *a, double *vo, VECT2 *vi );

/* aa^߂Ă邩mF*/
int b_BB_check_d( int num, double *dwk1, double *dwk2, char *titl1, char *titl2 );
int b_BB_check_v2( int num, VECT2 *dwk1, VECT2 *dwk2, char *titl1, char *titl2 );
/* kťZ */
int lu_kenzan( LUFACT *b );
/* s쐬*/
int lu_factorization(LUFACT *b, int	inperfect, int *rank, int **order, int **weight);
/* ts̍XVBinv(a)inv(ds)~inv(a) */
int lu_pivotting( LUFACT *b, int r, VECT2 *alpha2, double *iB_r);
/* ϊBinv(a)~̌vZɎg */
int lu_ftran_d1( LUFACT *b, double *vv);
int lu_ftran_d2( LUFACT *b, double *vv );
int lu_ftran_v21( LUFACT *b, VECT2 *vv );
int lu_ftran_v22( LUFACT *b, VECT2 *vv );
/* tϊB΁΁~inv(a)̌vZɎg */
int lu_btran_d1( LUFACT *b, double *vv, int e_col );
int lu_btran_d2( LUFACT *b, double *vv);
int lu_btran_v21( LUFACT *b, VECT2 *vv, int e_col );
int lu_btran_v22( LUFACT *b, VECT2 *vv);

/* 	ŃxNgł̑|o'Ł~̌vZBłcol񂪃ŃxNgő͒Pʍs*/
/*int lu_sweep_eta_d( double *vv, LUMATRX *lu, int head, int col ); */
/* us^Ł~uBxNguAł̓ς߂āAurɑB*/
int lu_row_eta_v2( VECT2 *vv, LUMATRX *lu, LUAVS *head, int row, int *idx );
/* vfmۂ̂lumx_new_av()ĂԂ */
int lumx_only_new_av( LUMATRX *lu );

/* ks̃_v */
int lu_dump_L(LUFACT *b);
/* ts̃_v */
int lu_dump_U(LUFACT *b);
int lu_dump_R(LUFACT *b);
/* pfv[j].pf_head lu->av[]̃_v */
int lu_dump_lu( LUMATRX *lu, int head, int j );
/* 	}b`Õ_v*/
int lu_dump_match(int (*mt)[2], int num, char *titl);

/*  Ot̋A */
int dgscg_s( int nnode,int *nscg,int (*scg)[2],int vlst[],int*,int*,int*
	,int (*reset_friend)(void),int (*get_friend)(int b) );
/*	i\̔Wg|WJ\[gB*/
int	tsort_s(int nnode,int order[],int node[],int self_ok,int (*reset_friend)(void),int (*get_friend)(int b));

/*	}b`O܂͊gĂktŎgvf̃Xg쐬 */
int b_make_mt(LUFACT *b, int inperfect);
/*	ubNOp */
int lp_block_sankaku( LUMATRX *lu, int sz, int (*mt)[2], BLOCK3 *b3, int inperfect );
/*	}b`OÂȂE_ԂB*/
int matching(int nboy,int ngal,int *match,int add,int (*reset_friend)(void),int (*get_friend)(int i) );
#if defined(__cplusplus)
//1 }
#endif

#endif /* ! defined(LPLUFACT_H) */
