/* lpvect.c ̃wb_
 * FILE      : lpvect3.h
 * SYSTEM    : 
 * FUNCTION  : OvfNtxNg
 * AUTHOR    : A.Yahagi  2002.01.09
 * SYNOPSIS  :
 */

/***************************************************************/
#if ! defined(lpvect3_h)
#define lpvect3_h

/* VECT1^ɒǉ */
#define LPVECT1_APPEND(vect, j, vv) \
	( (vect)->next[(j)] = (vect)->top, \
	(vect)->top = (j), \
	(vect)->va[(j)] = (vv) )
#define LPVECT1_SET(vect, j, vv) \
	(((vect)->next[(j)] >= -1) ? ((vect)->va[(j)] = (vv), 0) \
	: (LPVECT1_APPEND( vect, j, vv ), 1))
#define LPVECT1_ADD(vect, j, vv) \
	((vect)->next[(j)] >= -1) ? ((vect)->va[(j)] += (vv), 0) \
	: (LPVECT1_APPEND( vect, j, vv ), 1)
#define LPVECT1_GET(vect, j) \
	(((vect)->next[(j)] >= -1) ? (vect)->va[(j)] : 0)
/* VECT2^ɒǉ */
#define LPVECT2_APPEND(vect, j, vv) \
	( (vect)->next[(j)] = (vect)->top, \
	(vect)->top = (j), \
	(vect)->usef[(j)] = (vect)->nowf, \
	(vect)->va[(j)] = (vv) )/*, \*/
/*	(vect)->nz++ ) NT020508 del */
#define LPVECT2_SET(vect, j, vv) \
	(((vect)->usef[(j)] == (vect)->nowf) ? ((vect)->va[(j)] = (vv), 0) \
	: (LPVECT2_APPEND( vect, j, vv ), 1))
#define LPVECT2_ADD(vect, j, vv) \
	((vect)->usef[(j)] == (vect)->nowf) ? ((vect)->va[(j)] += (vv), 0) \
	: (LPVECT2_APPEND( vect, j, vv ), 1)
#define LPVECT2_GET(vect, j) \
	(((vect)->usef[(j)] == (vect)->nowf) ? (vect)->va[(j)] : 0.0)


/* ړI֐̌WxNgBNT060213add */
typedef struct {
	int n, x;
	double	s0;        /* ړI֐Ŝ̒萔{W NT030109ύX */
	/* XP[OŎgϐ*/
	double	ark;      /* XP[OŎg[N(ől) */
	double	ark2;     /* XP[OŎg[N(ŏl) */
	double	*v;
}VOBJECT;
struct TYPE2 {
	int 	aa;         /* l gp HY020531 */
	void	*maav;
};
/* O|C^tdoublez */
struct VECT1 {
	int		top;     /* 擪̔Ovf                 NT000702 nexti[]or-1 */
	int		*next;   /* [m+1]̔OvfB擪topB-2:NO  nexti[]or-1 */
	double	*va;     /* [m+1]doublezBOvf܂ޖȔz  */
	int		x_elem;  /* zva[]Ȃǂ̊mۗvf */
	int		n_elem;  /* zva[]Ȃǂ̎gpvfBOvfł͂ȂB */
} ;
struct VECT1c {
	int		top;     /* 擪̔Ovf                 NT000702 nexti[]or-1 */
	int		*next;   /* [m+1]̔OvfB擪topB-2:NO  nexti[]or-1 */
	char	*va;     /* [m+1]doublezBOvf܂ޖȔz  */
	int		x_elem;  /* zva[]Ȃǂ̊mۗvf */
	int		n_elem;  /* zva[]Ȃǂ̎gpvfBOvfł͂ȂB */
} ;
struct VECTIN {  /* YsԍƂxNg */
	double	v;         /* l */
	double	v_r;       /* {xvZp */
	int		next;      /* vf              vectin[] */
	int		usef;      /* gptOB-1:l s:gp s:gp */
} ;
/* P񂸂vZ鎞̂P񕪃xNgBVECT1̔W`  */
struct VECT2{  /* YsԍƂxNg */
	int		top;          /* 擪̗Lvf̓Y                 next[]or-1 */
	int		*next;        /*[x_elem] vfB擪top            next[]or-1 */
	double	*va;          /*[x_elem]doublezBe[]Ɠ̈gBNT021203  */
	TYPE2  *pa;    /*[x_elem]  */
/*	int		nz;           /* Ovf  NT020508 del */
	int		x_elem;       /* zva[]Ȃǂ̊mۗvf */
	int		n_elem;       /* zva[]Ȃǂ̎gpvfBOvfł͂ȂB */
	int		nowf;         /* ݗLusef̒l */
	int		*usef;        /*[x_elem] gptOB-1:l !=nowf:gp =nowf:L */
   	int		e_alloc_flag; /* 0:͏ʂŊmۍς 1:vect3Ŋmۋyfree */
#if defined(__cplusplus) 
	VECT2():x_elem(0){}
#else
#endif
} ;
/* SPCł̍s~xNgZpB NT011105 */
typedef struct spcVector_s {
	int		x_m;       /* v[]mۗvf */
	int		x_spc;     /* nz[]mۗvf */
	double	*v;        /* [m+1] xNglBY(spcԍ{spcs)Btopidxspcidx[]Œuς*/
	VECT2	*vc;       /* [n_spc] ON\́B                NT020126 */
   	int		nowf;      /* ݗLusef̒l NT020513 */ 
	int		top;       /* 擪̔VECT̔ԍ                    next[]or-1 */
	int		*next;     /* [n_spc]ubNB-2:NO 擪top    next[]or-1 */
}SPCVECT;

#if defined(__cplusplus) 
//1 extern "C" {
#endif
/* ړI֐l̃xNg NT060213add */
int exp_vobject( VOBJECT *c, int num);
int new_vobject( VOBJECT *c);
void free_vobject( VOBJECT *c);
/* SPCł̍s~xNgZp */
int spcv_free( SPCVECT *spcv);
int spcv_reset( SPCVECT *spcv, int n_spc );
int spcv_alloc( SPCVECT *spcv, int ma, int n_spc);
/* O|C^tz */
int lpvect1_free ( VECT1 *alpha );
int lpvect1_alloc( VECT1 *alpha, int m1 );
int lpvect1c_reset( VECT1c *vect );
int lpvect1c_free ( VECT1c *alpha );
int lpvect1c_alloc( VECT1c *alpha, int m1 );
int lpvect2_free ( VECT2 *vect );
int lpvect2_alloc( VECT2 *vect, int num, double *pe );
int lpvect2_reset( VECT2 *vect ); /*  */
int lpvect2_clean( VECT2 *vect ); /* Ovf폜 */
int lpvect2_copy( VECT2 *to, VECT2 *fr );
int lpvect2_make_link( VECT2 *vect );
int lpvect2_dump(char *title, VECT2 *vect );
//int lpsm_spc_nums( int k, int *n_row, int *top_row );
/* z̉`_v */
int ssc_dump_vect2d( VECT2 *v, int n, char *titl, int mode );
int ssc_dump_vect2( VECT2 *v, int n, char *titl, int mode );
#if defined(__cplusplus)
//1 }
#endif

/***************************************************************/
/* LPGW̃G[֘A̒萔l̒`       LpErrDefine.h  */
#if ! defined(MALLOC_ERROR)
#define	MALLOC_ERROR	-2	/* 蓖Ď̖߂l` 2000.09.28 K.Igarashi */
#endif /*! defined(MALLOC_ERROR)*/

#endif /*! defined(lpvect3_h)*/
