/*
 * FILE      : lutest.c
 * SYSTEM    : ktAό`Atsgđ^ako
 * FUNCTION  : beXgphCo[
 * AUTHOR    : N.Tsuchiya  2000.02.28
 */
#pragma warning(disable:4996) //wb_[ɓƏoȂȂB.Net2005
#pragma warning(disable:4018) //wb_[ɓƏoȂȂB.Net2005
#include <stdlib.h>  //rand
#include <vector>
#include <time.h>
using namespace std;
#include "lufact_uif.h"

char *fnameA = "aij.txt";
char *fnameB = "b.txt";
char *fnameX = "x.txt";
char *fnameE = "err.txt";
struct AIJ {
	int i, j;
	double a;
};
/*	ID_usage	
/*******************************************************************/
static void usage()
{
	char *msg ="usage: lufact.exe [-afile1] [-bfile2] [-xfile3] [-efile4]\n"
		"-a ()W̃t@CB  ȗlFaij.txt\n"
		"-b ()EӒl̃t@CBȗlFb.txt\n"
		"-x (o)t@CB    ȗlFx.txt\n"
		"-e (o)덷̃t@CB  ȗlFerr.txt\n";
	printf("%s", msg);
	return;
}
/*	ID_params	
/*******************************************************************/
static int params(  //0:@1:help(I) -1:G[
	int argc,
	char **argv)
{
	int k, rc;
	for( k = 1; k < argc; ++k ) {
		if( argv[k][0] == '-' || argv[k][0] == '/' ) {
			if       ( argv[k][1] == 'a' ) { fnameA = &argv[k][2];
			} else if( argv[k][1] == 'b' ) { fnameB = &argv[k][2];
			} else if( argv[k][1] == 'x' ) { fnameX = &argv[k][2];
			} else if( argv[k][1] == 'e' ) { fnameE = &argv[k][2];
			} else goto                                                 errp;
		} else goto                                                     errp;
	}
	rc = 0;
quit:
	return rc;
errp:
	printf("parameter error\n");
	usage();
	rc = -1; goto                                                       quit;
}
/*	ID_read_a_b	
/*******************************************************************/
static int read_a_b(
	 int *sz,             //o Ws̍s(=)
	 int *nz,             //o OW̐
	 vector<AIJ> *vecAij, //o
	 vector<double> *v)   //o
{
	FILE *fp = 0;
	AIJ aij;
	char bf[256], *fname;
	int rc, seq, i;
	double bi;

	*sz = *nz = 0;
	vecAij->clear();
	seq = 0;
	fname = fnameA;
	if( (fp = fopen(fname, "r")) == 0 ) goto                            erro;
	while( fgets(bf, sizeof(bf), fp) != 0 ) {
		++seq;
		if( bf[0] == '#' || bf[0] == '\n' ) continue;
		rc = sscanf(bf, "%d,%d,%le", &aij.i, &aij.j, &aij.a);
		if( rc != 3 ) goto                                              errd;
		if( aij.i < 0 || aij.j < 0 ) goto                               errd;
		if( *sz < aij.i + 1 ) *sz = aij.i + 1;
		if( *sz < aij.j + 1 ) *sz = aij.j + 1;
		if( aij.a != 0.0 ) {
			++(*nz);
			vecAij->push_back(aij);
		}
	}
	fclose(fp); fp = 0;
	v->resize(*sz);
	for( i = 0; i < *sz; ++i )
		(*v)[i] = 0.0;
	seq = 0;
	fname = fnameB;
	if( (fp = fopen(fname, "r")) == 0 ) goto                            erro;
	while( fgets(bf, sizeof(bf), fp) != 0 ) {
		++seq;
		if( bf[0] == '#' || bf[0] == '\n' ) continue;
		rc = sscanf(bf, "%d,%le", &i, &bi);
		if( rc != 2 )
			goto                                              errd;
		if( i < 0 || i >= *sz )
			goto                                    errd;
		(*v)[i] = bi;
	}
	if( v->size() != *sz ) goto                                         err1;
	rc = 0;
quit:
	if( fp ) {fclose(fp); fp = 0;}
	return rc;
erro:
	printf("cannot open file(%s)\n", fname);
	rc = -1; goto                                                       quit;
errd:
	printf("error data. file(%s) seq(%d)\n", fname, seq);
	rc = -1; goto                                                       quit;
err1:
	printf("unmatch size(%d) of the right side of an equation and size(%d) of the matrix\n"
		,v->size(), *sz);
	rc = -1; goto                                                       quit;
}
/*	ID_read_a_b	
/*******************************************************************/
static int write_x_e(
	vector<double> &b0,
	vector<double> &x,
	vector<double> &b1)
{
	FILE *fp = 0;
	char *fname;
	int rc, k;

	fname = fnameX;
	if( (fp = fopen(fname, "w")) == 0 ) goto                            erro;
	for( k = 0; k < x.size(); ++k ) {
		fprintf(fp, "%g\n", x[k]);
	}
	fclose(fp); fp = 0;

	fname = fnameE;
	if( (fp = fopen(fname, "w")) == 0 ) goto                            erro;
	for( k = 0; k < x.size(); ++k ) {
		fprintf(fp, "ftran k(%d) b(%g) x(%g) Ax(%g) Ax-b(%g)\n", k, b0[k], x[k], b1[k], b1[k] - b0[k] );
	}
	rc = 0;
quit:
	if( fp ) {fclose(fp); fp = 0;}
	return rc;
erro:
	printf("cannot open file(%s)\n", fname);
	rc = -1; goto                                                       quit;
}

/*	ID_compAij	
/*******************************************************************/
static int compAij(AIJ *p, AIJ *q)
{
	int rc = p->i - q->i;
	if( rc == 0 )
		rc = p->j - q->j;
	return rc;
}
/*	ID_unique_aij	
/*******************************************************************/
static int unique_aij(vector<AIJ> &vecAij)
{
	int i, j;
	qsort(&vecAij[0], vecAij.size(), sizeof(AIJ), (int(*)(const void*,const void*))compAij);
	for( i = j = 0; i < vecAij.size() && j < vecAij.size(); ++i, ++j ) {
		if( i != j ) vecAij[i] = vecAij[j];
		//(i,j)XLbv
		for( ; j < vecAij.size() - 1; ++j ) {
			if( compAij(&vecAij[j], &vecAij[j+1]) != 0 ) break;
		}
	}
	vecAij.resize(i);
	return i;
}

/*	ID_mult_mx_d	sƃxNg̊|ZBuoa~ui
/*******************************************************************/
static int mult_mx_d(
	int sz,       //i
	int nz,       //i
	AIJ *aij,     //i
	double *vo,   //o
	double *vi)   //i
{
	int i, j, k;
	memset( vo, 0, sizeof(double) * sz );
	for( k = 0; k < nz; ++k ) {
		i = aij[k].i;
		j = aij[k].j;
		vo[i] += vi[j] * aij[k].a;
	}
	return 0;
}
/*	ID_mult_d_mx	xNgƍs̊|ZBuoui~`
/*******************************************************************/
static int mult_d_mx(
	int sz,       //i
	int nz,       //i
	AIJ *aij,     //i
	double *vo,   //o
	double *vi)   //i
{
	int i, j, k;
	memset( vo, 0, sizeof(double) * sz );
	for( k = 0; k < nz; ++k ) {
		i = aij[k].i;
		j = aij[k].j;
		vo[j] += vi[i] * aij[k].a;
	}
	return 0;
}
/*	ID_lu_test1_calc	
/*******************************************************************/
static int lu_test1_calc(
	void *lu,
	int sz,
	int nz,
	vector<AIJ> &vecAij,
	vector<double> &v,
	int dbgf)
{
	int rc, k, rank, *order, *weight;
	double epsi = 1e-6;
	vector<double> r1, r2;
	r1.resize(sz);
	r2.resize(sz);
	/* kts̗̈mۂƏ */
	rc = lu_resize( lu, sz );
	if( rc < 0 ) goto                                                  quit;
	for( k = 0; k < nz; ++k ) {
		/* ktšWz̖ɒǉB(s,)Qȏǉƌʂ͕ۏ؂Ȃ */
		rc = lu_append( lu, vecAij[k].i, vecAij[k].j, vecAij[k].a);  // 0<=rc< nz+sz
	}
	/* kt*/
	rc = lu_factoring(lu, 0, &rank, &order, &weight);
	if( (rc = sz - rank) != 0 ) goto                                    err1;
	/* ϊBinv(a)~̌vZ */
	rc = lu_ftran(lu, &r1[0], &v[0]);
	/* sƃxNg̊|ZBuoa~ui */
	rc = mult_mx_d( sz, nz, &vecAij[0], &r2[0], &r1[0] );
	if( rc == 0 ) {
		write_x_e(v, r1, r2);
	}
	rc = 0;
quit:
	return rc;
err1:
	printf("Ns@size = %d, rank = %d\n", sz, rank );
	goto                                                                quit;
}
/*	ID_lu_test1	
/*******************************************************************/
static int lu_test2(void *lu)
{
	int rc, sz, nz, dbgf = 0;
	vector<AIJ> vecAij;
	vector<double> v;
	clock_t	ck1, ck2;   /*  */
#ifdef _DEBUG_SSC
	dbgf = 1;
#endif
	if( (rc = read_a_b(&sz, &nz, &vecAij, &v)) != 0 ) goto quit;
	rc = unique_aij(vecAij);
	if( nz != rc ) {
		printf("same %d (i,j)'s are rejected.\n", nz - rc );
		nz = rc;
	}
	ck1 = clock() ;
	rc = lu_test1_calc(lu, sz, nz, vecAij, v, dbgf);
	ck2 = ck1; ck1 = clock() ;
	printf("sz = %d nz = %d rc = %d clock = %.2f\n", sz, nz, rc, (ck1 - ck2) / (double)CLOCKS_PER_SEC );
quit:
	return rc;
}
//int test();
/*	ID_main	
/*******************************************************************/
int main(int argc, char **argv)
{
//	test();
	int rc;
	void *lu;
	vector<AIJ> vecAij;
	vector<double> v;
	//int ymd;
	//struct tm *tm1;
	//time_t ltime;

	////t`FbN 20161231 ȍ~Ȃ  2013.08.21 YS
	//time( &ltime );
    //tm1 = gmtime( &ltime );
	//ymd = (tm1->tm_year +1900)*10000 + (tm1->tm_mon+1)*100 + tm1->tm_mday;
	//if( ymd > 20161231 ) goto quit; 

	if( (rc = params(argc, argv)) != 0 ) goto                           quit;

	//kts̗̈𐶐
	lu = lu_new();
	//eXgs
	rc = lu_test2(lu);
	//ktts̗̈J
	lu_delete(lu);
#ifdef _DEBUG
	printf("press enter key\n"); fflush(stdout);
	scanf("%c", &rc);
#endif
quit:
	return 0;
}

